!> \file mass-ant_perturb-0.4.f
!! Calcule du bilan de masse avec une evolution perturbative
!<

!> SUBROUTINE:  MASSB_ANTEIS_PERTURB ()
!! \author Vincent 
!! \date  juin2004
!! @note Cette routine calcul le bilan de masse avec une evolution perturbative
!! @note copie de massbal-anteis-0.2.f (sans changements)
!! @note Used modules:
!! @note    - use module3D_phy
!! @note    - use CLIMAT_PERTURB_MOD
!<
      subroutine MASSB_ANTEIS_PERTURB ()
c     subroutine Mass Balance eismint pour l'Antarctique

       USE module3D_phy
      USE CLIMAT_PERTURB_MOD

      implicit none
! Vincent juin2004 : copie de massbal-anteis-0.2.f (sans changements)
! Cette routine calcul le bilan de masse avec une evolution perturbative
! on utilise TAFOR     


         if (itracebug.eq.1)  call tracebug(
     &         ' Antar: entree dans MASSB_ANTEIS_PERTURB ')

c     surface temperature et accumulation
      do J=1,NY
        do I=1,NX

c       les quatres lignes suivantes sont pour la temperature parametree

c             TANN(I,J)=34.46-0.00914*S(I,J)-0.68775*abs(YLAT(i,j))
c             TANN(I,J)=TANN(I,J)+TAFOR
c            TJULY(I,J)=16.81-0.00692*S(I,J)-0.27973*abs(YLAT(I,J))
c             TJULY(I,J)=TJULY(I,J)+TAFOR

c       Pour utiliser la carte de temperature, on utilise les
c       gradients de la parametrisation et on garde la meme
c       amplitude saisonniere
c            TJULY=TANN+(16.81-34.46)-(0.00692-0.00914)S(I,J)
c                      -(0.27973-0.68775)YLAT(I,J)
c            TJULY=TANN-17.65+0.00222*S(I,J)+0.40802*Ylat(i,j)

c       les lignes suivantes sont pour la temperature "carte"

             if(RETROAC.eq.1) then
                Tann(i,j)=TA0(I,J)-0.00914*(S(i,j)-S0(I,J))+TAFOR
                 TJULY(I,J)=TANN(I,J)-17.65+0.00222*S(I,J)
     &                                 +0.40802*abs(YLAT(I,J))


                  if (icouple.eq.2) then
!                   ACC(I,J)=1.5*2.**(Tann(I,J)/10.)
                   else if (icouple.eq.4) then

!                   ACC(I,J)=PRECIP(I,J)*exp(0.070*(TANN(I,J)-TA0(I,J)))

                ACC(I,J)=PRECIP(I,J)*exp(rappact*(TANN(I,J)-TA0(I,J)))

c                  ACC(I,J)=1.5*2.**(Tann(I,J)/10.)  ! test pour pref8
                  endif

           else if(RETROAC.eq.0) then
                 Tann(i,j)=TA0(I,J)
                 TJULY(I,J)=TANN(I,J)

                  if (icouple.eq.2) then
!                ACC(I,J)=1.5*2.**(Tann(I,J)/10.)
c            	   ACC(I,J)=(Tann(I,J)/10.)
                  else if (icouple.eq.4) then
C             	  ACC(I,J)=PRECIP(I,J)
c                 ACC(I,J)=1.5*2.**(Tann(I,J)/10.)  ! test pour pref8
                ACC(I,J)=PRECIP(I,J)*exp(rappact*(TANN(I,J)-TA0(I,J)))
                  endif

           endif

        end do
      end do

c     ablation et bilan de masse
c       call ablation()
      
      debug_3D(:,:,29)=Tann(:,:)-Ta0(:,:)
      debug_3D(:,:,30)=Acc(:,:)-precip(:,:)
      debug_3D(:,:,31)=Acc(:,:)-bmelt(:,:)

      

      return
      end
