!> \file paradim-ant45_CISM_mod.f90
!! Def des dimensions du grille CISM a 15 km  
!<

!> \namespace module_ant45_CISM
!! Def des dimensions du grille CISM a 15 km  
!! \author ...
!! \date ...
!! @note prescribe nx,ny,  dimension of most arrays
!! for Antarctic 45 km grid CISM
!<

module module_ant45_CISM

implicit none

! character
character(len=7),  parameter  ::  geoplace='CISMA45'
character(len=23), parameter  :: dirnameinp='../INPUT/ANT-CISM-45km/' !< input directory
character(len=17), parameter  :: dirforcage='../INPUT/Forcage/' !< input directory

! dimensionnement grilles
!-------------------------
integer, parameter :: nx=134           !< dimension selon x (indice i)
integer, parameter :: ny=134           !< dimension selon y (indice j)
integer, parameter :: nlmin=134        !< min(nx,ny), pour matrice elliptique  
integer, parameter :: nz=21            !< dimension selon z (indice k) 
integer, parameter :: nzm=4            !< nb de points verticaux dans le socle
integer, parameter :: nn=199           !< pour des sorties


! pas horizontal
!-----------------
real, parameter    :: dx=45000.0      !< pas en X en m
real, parameter    :: dy=45000.0      ! pas en Y en m


end module module_ant45_CISM
