!> \file ablation-2007pey_et_al.f90
!! File pour le calcule de l'ablation
!<

!> SUBROUTINE: ABLATION_2007pey_et_al
!! \author ...
!! \date 2007
!! @note  Routine qui calcule l'ablation
!! @note Used modules:
!! @note    - use module3D_phy
!! @note    - use printtable
!<



!*******************************************************************

      subroutine ABLATION_2007pey_et_al()

!     *********************************************************
!     (******** ABLATION ********)
!     *********************************************************


      use module3D_phy
       use printtable

      implicit none
        
      real,dimension(nx,ny) :: snow, melt  
      real :: frac
      integer :: meth_abl_vi
      
       meth_abl_vi=1 ! pdd normal
       meth_abl_vi=2 ! pdd + param dadpte Gerard

!      Csnow=0.015 !/Csnow !!!! E7cyc1
!      Cice =0.028 !0.020
!      Csnow=0.010 !/Csnow !!!! E7cyc3
!      Cice =0.021 !
       Csnow=0.008 !/Csnow !!!! E7cyc4
       Cice =0.017 !
       print*,'Csnow Cice',Csnow,Cice

         if (ntrace.eq.1) then
          open(81,file='trace-reboot')
          write (81,*)'time=',time
          write (81,*)'ablation'
          close(81)
         endif 
!     (*** positive degree days ***)
      do I=1,NX
      do J=1,NY
        SUMM=0.0
        frac=0.0
        do NDAY=1,NYEAR   
          TT(NDAY)=TANN(I,J)+(TJULY(I,J)-TANN(I,J))*cos(PY*NDAY) 
          TEMP=0.0 
          do K=1,50
            if (TEMP.gt.TT(NDAY)+2.5*SIGMA) goto 205
            SUMM=SUMM+TEMP*exp(-(TEMP-TT(NDAY))*(TEMP-TT(NDAY))*S22) 
            TEMP=TEMP+DTP
          end do
205       continue
        end do
        PDD(I,J)=SUMM*PDDCT 
      end do
      end do

!     (*** ablation ***)
      do I=1,NX
      do J=1,NY
!       (* Positive degrees required to melt the snow layer *)
!       mass balance Vince sept 2006  
!-0  :  snowfall
        snow(I,J)=FT(i,j)*precip(i,j)
!       PDS=ACC(I,J)/Csnow 
        PDS=snow(I,J)/Csnow
!       (* Maximum amount of super. ice that can be formed *)
        SIMAX=ACC(I,J)*CSI
!       (* Pos. degrees required to melt the superimposed ice *)
        PDSI=SIMAX/Cice
        if (PDD(I,J).le.CSI*PDS) then
          SIF=PDD(I,J)*CSNOW
        else 
          SIF=SIMAX 
        endif

!       surface temperature
        TS(I,J)=(TANN(I,J)+26.6*SIF)
        TS(I,J)=min(0.0,TS(I,J))
        TSHELF(I,J)=TS(I,J)

        if (meth_abl_vi==1) then ! ancienne abla
!       mass balance
! ----- ancienne version 
        if (PDD(I,J).le.CSI*PDS)  BM(I,J)=ACC(I,J) 
        if ((CSI*PDS.LT.PDD(I,J)).and.(PDD(I,J).le.PDS))  &
         BM(I,J)=ACC(I,J)+SIMAX-PDD(I,J)*Csnow 
        if ((PDS.lt.PDD(I,J)).and.(PDD(I,J).le.PDS+PDSI)) &
         BM(I,J)=SIMAX-(PDD(I,J)-PDS)*Cice
        if (PDS+PDSI.le.PDD(I,J)) BM(I,J)=(PDS+PDSI-PDD(I,J))*Cice
        ABL(I,J) = Acc(I,J) - BM(I,J)
! =====================================================        
        elseif (meth_abl_vi==2) then ! abla vince 2006
!       mass balance Vince sept 2006  
!       H(i,j)=10.
!              frac=1-( (melt(i,j)/snow(I,J)) -.7)/.3
!              frac=max(0.,frac)
!              frac=min(1.,frac)
!-1  :  melting snow
!!!            if (PDD(I,J).le.10) then
!!!               melt(i,j)=PDD(I,J)*.03              
!!!            else  
                  melt(i,j)=PDD(I,J)*Csnow  
!!!            endif   
               melt(i,j)=min(snow(i,j),melt(i,j))
!-2  : fraction de regel 
             if (snow(i,j)==0) then
               frac=1
             else
               frac=1-( (melt(i,j)/snow(I,J)) -.7)/.3
!               frac=min(1.,frac)
             endif
!-4  : Ablation
               if (frac.lt.1.) then 
                  ABL(I,J)= (1-frac) * melt(i,j)
                  if ( PDD(I,J).gt.pds ) then
                     melt(i,j)=melt(I,J)+(PDD(I,J)-PDS)*Cice
                     ABL(I,J) = ABL(I,J)+(PDD(I,J)-PDS)*Cice
                  endif
               else 
                  ABL(I,J)=melt(i,j)  
               endif
!-4  : Ablation       
!vi!!-3  : Accumulation  : snowfall + fraction of rainfall
       Acc(I,J)=snow(I,J) !+ frac*( precip(i,j)-snow(i,j) )
       if (frac.lt.1. .and. frac.gt.0.) then
           Acc(I,J)= Acc(I,J) + frac*(precip(i,j)-snow(i,j))
       endif    
!vi!       Acc(I,J)=precip(I,J) !+ frac*( precip(i,j)-snow(i,j) )
!       ABL(I,J)= (1-frac) * melt(i,j)
!-5  : Mass balance : acc  - abl
       BM(I,J)=Acc(I,J) - ABL(I,J)
          
        endif
        
      end do
      end do

!     nom_table='melt_L'
!     call printtable_r(melt,nom_table)
!     nom_table='snow_L'
!     call printtable_r(snow,nom_table)
!940   format('%%%% ',a,'   time=',f8.0,' %%%%')
      end
