# Makefile de GRISLI - compilo et options pour Cat (pc-226)
# FT options de compilation
# LK options de link

# Rappel de quelques options interessantes
#-------------------------------------------
# faire imperativement attention a l'arithmetique
# -fpe0 s'arrete sur les floating point exception (sauf underflow)
# -CB  Performs run-time checking on array subscript and character substring expressions
# -g pour debug 
# -pg pour le profiling
# -traceback permet de connaitre la ligne qui plante

# faire man ifort pour plus d'infos

# le directory dans lequel sont les compilateurs et MKL
# DIRLOCAL=/usr/local variable d'environnement a definir dans .bash_profile

debug ?= 0

# lit le nom du fichier param pour lancer sur r2d2 par une commande :   echo jobparam | LBQ....

JOB = 'job'

LIBSYS = /usr/lib
INCSYS = /usr/include

# librairies

NCDF_INC  = $(INCSYS)
NCDF_LIB  = -L$(LIBSYS) -lnetcdff -lnetcdf

IFORT= gfortran

ARITHMi    = -O2 -ffree-line-length-none -mtune=native -mfpmath=sse

ifeq ($(debug), 1)
    ARITHM  = $(ARITHMi) -g -pg -Wall -fno-align-commons -p -ggdb -ffpe-trap=invalid,zero,overflow,underflow -fbacktrace -fcheck=all
else
    ARITHM = $(ARITHMi)
endif


# debug : -g -CB -fp-stack-check -check all
FT        = $(IFORT) $(ARITHM) -c
LK        = $(IFORT) $(ARITHM)
F_NETCDF  = $(IFORT) $(ARITHM) -c -I$(NCDF_INC)
F_90      =

# The End of All Things (op. cit.)
